class Mouse_Events

  MOVE = 1
  RESIZE = 2

  def initialize(height,width)
    @height=height
    @width=width
  end

  def height=(height)
    @height=height
  end
  def width=(width)
    @width=width
  end

  def length
    if @height < @width then
      @height
    else
      @width
    end
  end
  def xoffset
    (@width-length)/2
  end
  def yoffset
    (@height-length)/2
  end

  def pressed(px,py,l,r,b,t)
    @move = false
    @left,@right,@bottom,@top, = l,r,b,t
    @axis = where(px,py,l,r,b,t)
    if @axis then
      if @axis==4 then
	@move=MOVE
	@bpx,@bpy, = px,py
	p "begin move"
      else
	@move=RESIZE
	p "begin resize"
      end
    else
      @move = false
    end
  end
  def released(px,py)
    print "released:",px,",",py,"\n"
    if @move==MOVE then
      @move=false
      p "end move"
      dx=px-@bpx
      dy=py-@bpy
      [@left+dx,@right+dx,@bottom+dy,@top+dy]
    elsif @move==RESIZE then
      @move=false
      p "end resize"
      l,r,b,t, = @left,@right,@bottom,@top
      @left=nil;@right=nil;@bottom=nil;@top=nil
      @bpx=nil;@bpy=nil
      set(px,py,l,r,b,t)
    end
  end
  def draged(w,px,py)
    if @move==MOVE then
      gc = w.style.fg_gc(w.state)
      x = (@left+px-@bpx)*length+xoffset
      y = (1-@top-py+@bpy)*length+yoffset
      xl = length*(@right-@left)
      yl = length*(@top-@bottom)
      w.window.draw_rectangle(gc, false, x, y, xl, yl)
    elsif @move==RESIZE then
      l,r,b,t, = set(px,py,@left,@right,@bottom,@top)
      gc = w.style.fg_gc(w.state)
      x = l*length+xoffset
      y = (1-t)*length+yoffset
      xl = length*(r-l)
      yl = length*(t-b)
      w.window.draw_rectangle(gc, false, x, y, xl, yl)
    end
  end

  def where(px,py,l,r,b,t)
    width = 0.01
    if (px>l-width)&&(px<r+width)&&(py>b-width)&&(py<t+width) then
      if (px-l).abs < width then
	0
      elsif (px-r).abs < width then
	1
      elsif (py-b).abs < width then
	2
      elsif (py-t).abs < width then
	3
      else
	4
      end
    else
      false
    end
  end

  def move?
    @move
  end

  def set(px,py,l,r,b,t)
    diff=0.05
    lo,ro,bo,to, = [l,r,b,t]
    if @axis==0 then
      if px<diff then
	lo=diff
      elsif px>(r-diff) then
	lo=r-diff
      else
	lo=px
      end
    elsif @axis==1 then
      if px>(1-diff) then
	ro=1-diff
      elsif px<(l+diff) then
	ro=l+diff
      else
	ro=px
      end
    elsif @axis==2 then
      if py<diff then
	bo=diff
      elsif py>(t-diff) then
	bo=t-diff
      else
	bo=py
      end
    elsif @axis==3 then
      if py>(1-diff) then
	to=1-diff
      elsif py<(b+diff) then
	to=b+diff
      else
	to=py
      end
    end
    [lo,ro,bo,to]
  end

end

